[build-system]
build-backend = "setuptools.build_meta"
requires = ["setuptools>=64"]

[project]
name = "charmed-django"
version = "0.3.0"
description = "A Django project deployed as a Juju Charm"
readme = "README.md"
license = {file = "LICENSE"}
authors = [
  {name = "Painless Software", email = "info@painless.software"},
]
maintainers = [
  {name = "Painless Software", email = "info@painless.software"},
]
classifiers = [
  "Development Status :: 4 - Beta",
  "Framework :: Django",
  "Intended Audience :: Information Technology",
  "License :: Other/Proprietary License",
  "Programming Language :: Python :: 3",
  "Programming Language :: Python :: 3.10",
  "Programming Language :: Python :: 3.11",
  "Programming Language :: Python :: 3.12",
]
keywords = [
  "django",
]
requires-python = ">=3.10"
dependencies = [
  "dj_database_url",
  "django==4.2.*",
  "python-decouple",
  "django-htmx",
  "djangorestframework",
  "gunicorn[gthread]",
  "psycopg",
  "whitenoise[brotli]",
]

[project.optional-dependencies]
dev = [
  "django-browser-reload",
  "django-debug-toolbar",
]

[project.scripts]
"manage.py" = "application.manage:main"

[project.urls]
homepage = "https://gitlab.com/painless-software/cicd/examples"

[tool.behave]
junit = true
junit_directory = "tests"
paths = ["tests/acceptance"]
show_skipped = false
summary = false

[tool.coverage.report]
exclude_also = ["if __name__ == .__main__.:"]
show_missing = true
skip_covered = true

[tool.coverage.run]
source = ["."]
omit = ["tests/*"]

[tool.mypy]
exclude = [
  "tests/",
]
ignore_missing_imports = true
pretty = true
warn_redundant_casts = true
warn_unreachable = true
warn_unused_ignores = true

[tool.pytest.ini_options]
addopts = "--color=yes --doctest-modules --ignore=tests/acceptance --junitxml=tests/junit-report.xml --verbose"
python_files = ["tests.py", "test_*.py", "*_tests.py"]
DJANGO_SETTINGS_MODULE = "application.settings"
FAIL_INVALID_TEMPLATE_VARS = true

[tool.ruff]
extend-exclude = ["migrations"]
extend-include = []

[tool.ruff.lint]
extend-select = ["ALL"]
extend-ignore = ["ARG005", "ANN", "D", "INP", "RUF012"]

[tool.ruff.lint.per-file-ignores]
"application/urls.py" = ["RUF005"]
"tests/**/*.py" = ["S101"]
"tests/acceptance/**/*.py" = ["ARG001", "ERA001", "F821"]

[tool.setuptools.packages.find]
namespaces = false
